unit c_modify;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32, GR32_Image, JvExControls, JvComponent, JvXPCore, JvXPButtons,
  StdCtrls, TFlatMemoUnit, ExtCtrls, TFlatPanelUnit, TFlatEditUnit,
  TntStdCtrls, TntExtCtrls, xmldom, XMLIntf, msxmldom, XMLDoc, TypInfo,
  Buttons, TntButtons;

type
  Tc_modify_form = class(TForm)
    Btn_Previous_Image: TTNTButton;
    Btn_Next_Image: TTNTButton;
    Btn_OK: TTntButton;
    Panel1: TTNTPanel;
    FlatPanel2: TFlatPanel;
    Image321: TImage32;
    Btn_Cancel: TTntButton;
    Label_Comments: TTntLabel;
    FlatEdit1: TTNTEdit;
    Label_Title: TTntLabel;
    Panel2: TTNTPanel;
    Label3: TTNTLabel;
    Btn_Rotate_90: TTntBitBtn;
    Btn_Rotate_270: TTntBitBtn;
    Btn_Flip_V: TTntBitBtn;
    Btn_Flip_H: TTntBitBtn;
    FlatMemo1: TTntEdit;
    procedure Btn_Next_ImageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Btn_Previous_ImageClick(Sender: TObject);
    procedure Btn_OKClick(Sender: TObject);
    procedure Btn_CancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Btn_Rotate_90Click(Sender: TObject);
    procedure Btn_Rotate_270Click(Sender: TObject);
    procedure Btn_Flip_VClick(Sender: TObject);
    procedure Btn_Flip_HClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Deal_Thumbnail(index: integer);
    procedure SaveInfo(index: integer);
    procedure LoadInfo(index: integer);
  end;

var
  c_modify_form: Tc_modify_form;
  rotate_int, flip_v_int, flip_h_int : Integer;  

implementation

uses c_main;

{$R *.dfm}

var
  cur_index : Integer;

procedure Tc_modify_form.Btn_Next_ImageClick(Sender: TObject);
begin
  SaveInfo(cur_index);
  cur_index := cur_index + 1;
  Deal_Thumbnail(cur_index);
end;

procedure Tc_modify_form.Btn_Previous_ImageClick(Sender: TObject);
begin
  SaveInfo(cur_index);
  cur_index := cur_index - 1;
  Deal_Thumbnail(cur_index);
end;

procedure Tc_modify_form.Deal_Thumbnail(index: integer);
var
  U_Width, U_Height : integer;
  U_Biger: integer;
begin
  try
    cur_index := index;
    LoadInfo(cur_index);

    Btn_Previous_Image.Enabled := True;
    Btn_Next_Image.Enabled := True;

    if cur_index = 0 then
    begin
      Btn_Previous_Image.Enabled := False;
      Btn_Next_Image.Enabled := True;
    end;

    if cur_index = Mainform.ListView1.Items.Count -1 then
    begin
      Btn_Previous_Image.Enabled := True;
      Btn_Next_Image.Enabled := False;
    end;

   Image321.Bitmap.LoadFromFile(Mainform.ListView1.Items[index].SubItems[3]);

//  Image321.Bitmap := Mainform.Image321.Bitmap;

   U_Width := Image321.Bitmap.Width;
   U_Height := Image321.Bitmap.Height;

    if U_Width >= U_Height then U_Biger := U_Width else U_Biger := U_Height;

    if (U_Width > 326) or (U_Height > 326) then
    begin
      Image321.ScaleMode := smScale;
      Image321.Scale := 326 / U_Biger;
    end
    else
      Image321.ScaleMode := smNormal;

    Image321.Bitmap.StretchFilter := sfLanczos;

    Mainform.COME_Deal_Rotate_Flip(Image321.Bitmap, rotate_int, flip_v_int, flip_h_int);

    Label3.Caption := Format('%s / %s : %s x %s, %s',
                            [IntToStr(cur_index+1),IntToStr(Mainform.ListView1.Items.Count),
                             IntToStr(U_Width),IntToStr(U_Height),Mainform.MyGetFileSize(Mainform.ListView1.Items[cur_index].SubItems[3])]);
  except
  end;
end;

procedure Tc_modify_form.FormCreate(Sender: TObject);
begin
//  Mainform.Image321.Bitmap.Delete;
end;

procedure Tc_modify_form.SaveInfo(index: integer);
begin
  mainform.ListView1.Items[index].SubItems[0] := FlatEdit1.Text;
  mainform.ListView1.Items[index].SubItems[1] := FlatMemo1.Text;

  mainform.ListView1.Items[index].SubItems[6] := IntToStr(rotate_int);
  mainform.ListView1.Items[index].SubItems[7] := IntToStr(flip_v_int);
  mainform.ListView1.Items[index].SubItems[8] := IntToStr(flip_h_int);
end;

procedure Tc_modify_form.LoadInfo(index: integer);
begin
  FlatEdit1.Text := mainform.ListView1.Items[index].SubItems[0];
  FlatMemo1.Text := mainform.ListView1.Items[index].SubItems[1];

  rotate_int := StrToIntDef(mainform.ListView1.Items[index].SubItems[6], 0);
  flip_v_int := StrToIntDef(mainform.ListView1.Items[index].SubItems[7], 0);
  flip_h_int := StrToIntDef(mainform.ListView1.Items[index].SubItems[8], 0);
end;

procedure Tc_modify_form.Btn_OKClick(Sender: TObject);
begin
  SaveInfo(cur_index);
  Close;
end;

procedure Tc_modify_form.Btn_CancelClick(Sender: TObject);
begin
  Close;
end;

procedure Tc_modify_form.FormShow(Sender: TObject);
var
  XMLBox : TXMLDocument;
  Root, Cur_Nodes : IXMLNode;
  i,j : Integer;
begin
  if not(G_for_Language) then Deal_Thumbnail(Mainform.ListView1.Selected.Index);
  if G_Language_Filename = 'language_en.xml' then Exit;

  XMLBox := TXMLDocument.Create(Self);
  XMLBox.LoadFromFile(APP_LANGUAGE_PATH + G_Language_Filename);
  Root := XMLBox.DocumentElement;
  Cur_Nodes := Root.ChildNodes.Nodes['ModifyForm'];
  for i := 0 to Cur_Nodes.ChildNodes.Count - 1 do
  begin
   if FindComponent(Cur_Nodes.ChildNodes.Nodes[i].LocalName) <> nil then
     if FindComponent(Cur_Nodes.ChildNodes.Nodes[i].LocalName).Tag = 8 then
        for j := 0 to Cur_Nodes.ChildNodes.Nodes[i].ChildNodes.Count -1 do
        begin
          try
            SetPropValue(FindComponent(Cur_Nodes.ChildNodes.Nodes[i].LocalName), Cur_Nodes.ChildNodes.Nodes[i].ChildNodes.Nodes[j].LocalName, Cur_Nodes.ChildNodes.Nodes[i].ChildNodes.Nodes[j].Text);
          except
          end;
        end;
  end;
  XMLBox.Free;
end;

procedure Tc_modify_form.Btn_Rotate_90Click(Sender: TObject);
begin
  Image321.Bitmap.Rotate90();
  rotate_int := rotate_int + 90;
end;

procedure Tc_modify_form.Btn_Rotate_270Click(Sender: TObject);
begin
  Image321.Bitmap.Rotate270();
  rotate_int := rotate_int + 270;
end;

procedure Tc_modify_form.Btn_Flip_VClick(Sender: TObject);
begin
  Image321.Bitmap.FlipVert();
  flip_v_int := flip_v_int + 1;
end;

procedure Tc_modify_form.Btn_Flip_HClick(Sender: TObject);
begin
  Image321.Bitmap.FlipHorz();
  flip_h_int := flip_h_int + 1;
end;

end.
